import math

def displacement_menu():
    print("Displacement Calculator")
    print("1: s = vi*t + 0.5*a*t^2")
    print("2: s = ((vi + vf)/2) * t")
    print("3: s = (vf^2 - vi^2) / (2*a)")
    print("4: s = v * t  (Constant Velocity)")
    print("5: Projectile Horizontal Displacement (s = (v0^2*sin(2θ))/g)")
    print("6: Arc Length in Circular Motion (s = r * θ)")
    choice = input("Choose a method (1-6): ")
    return choice

def displacement_via_kinematics():
    # Using: s = vi*t + 0.5*a*t^2
    print("\nMethod 1: s = vi*t + 0.5*a*t^2")
    vi = float(input("Enter initial velocity (vi): "))
    t = float(input("Enter time (t): "))
    a = float(input("Enter acceleration (a): "))
    s = vi * t + 0.5 * a * t**2
    print("Displacement (s) =", s)

def displacement_via_average_velocity():
    # Using: s = ((vi + vf)/2) * t
    print("\nMethod 2: s = ((vi + vf)/2) * t")
    vi = float(input("Enter initial velocity (vi): "))
    vf = float(input("Enter final velocity (vf): "))
    t = float(input("Enter time (t): "))
    s = ((vi + vf) / 2) * t
    print("Displacement (s) =", s)

def displacement_via_v_squared():
    # Using: s = (vf^2 - vi^2) / (2*a)
    print("\nMethod 3: s = (vf^2 - vi^2) / (2*a)")
    vi = float(input("Enter initial velocity (vi): "))
    vf = float(input("Enter final velocity (vf): "))
    a = float(input("Enter acceleration (a): "))
    if a == 0:
        print("Acceleration cannot be zero for this formula.")
        return
    s = (vf**2 - vi**2) / (2 * a)
    print("Displacement (s) =", s)

def displacement_constant_velocity():
    # Using: s = v * t
    print("\nMethod 4: s = v * t (Constant Velocity)")
    v = float(input("Enter velocity (v): "))
    t = float(input("Enter time (t): "))
    s = v * t
    print("Displacement (s) =", s)

def projectile_horizontal_displacement():
    # Using: s = (v0^2 * sin(2θ)) / g
    print("\nMethod 5: Projectile Horizontal Displacement")
    v0 = float(input("Enter initial velocity (v0): "))
    theta_deg = float(input("Enter launch angle (θ in degrees): "))
    g = float(input("Enter gravitational acceleration (g) [~9.81 m/s^2]: "))
    theta_rad = math.radians(theta_deg)
    s = (v0**2 * math.sin(2 * theta_rad)) / g
    print("Horizontal Displacement (s) =", s)

def circular_arc_length():
    # Using: s = r * θ
    print("\nMethod 6: Arc Length in Circular Motion")
    r = float(input("Enter radius (r): "))
    theta_rad = float(input("Enter angle (θ in radians): "))
    s = r * theta_rad
    print("Arc Length (s) =", s)

def main():
    choice = displacement_menu()
    
    if choice == '1':
        displacement_via_kinematics()
    elif choice == '2':
        displacement_via_average_velocity()
    elif choice == '3':
        displacement_via_v_squared()
    elif choice == '4':
        displacement_constant_velocity()
    elif choice == '5':
        projectile_horizontal_displacement()
    elif choice == '6':
        circular_arc_length()
    else:
        print("Invalid choice.")

# Automatically run the program without having to type 'main()'
main()
